/**
 * ---------- ПРИМЕРЫ --------------- *
 *            ФУНКЦИИ
 * ---------------------------------- *
 */

/* -------------- №1 ---------------- */
/* --------- ОБЪЯВЛЕНИЕ ------------- */
// function имя(параметры) {
//     ...тело...
// }
// объявление функции
function say_hi() {
    console.log('Hello world');
}

/* ------------- №2 ----------------- */
/* -------- ВЫЗОВ ФУНКЦИИ ----------- */
say_hi();
say_hi();

/* ------------- №3 ----------------- */
/* ----- ЛОКАЛЬНЫЕ ПЕРЕМЕННЫЕ ------- */
// Переменные, которые мы объявили внутри функции
// называются локальными и не могут использоваться вне ее объявления
function say_hi_() {
    // локальная переменная
    let message = "Привет!";
    // вывод значения переменной
    console.log(message);
}
say_hi_(); // Привет!
// переменная видна только внутри функции
// console.log(message);  // Ошибка!

/* ------------- №4 ----------------- */
/* ------- ВНЕШНИЕ ПЕРЕМЕННЫЕ ------- */
// Внутри функции можно получить также и внешние переменные,
// которые объявлены вне функции и менять при этом их значение
let vari = 2;
function changeVari() {
    let varible = 2; // локальная переменная
    vari += varible // изменяем значение внешней переменной
}
console.log(vari); // вывод 2
changeVari();
console.log(vari); // вывод 4

/* --------------- №5 --------------- */
/* ----------- ПАРАМЕТРЫ ------------ */
// После того как параметры определены мы можем их
// использовать внутри функции
// Пусть наша функция в качестве параметров
// принимает Имя и Фамилию и выводит приветствие
function showMessage(name, secondName) {
    // аргументы: name, secondName
    console.log('Привет!' + name + ' ' + secondName);
}
let name1 = 'Вася'
let secName = "Петров"
showMessage('Аня', 'Иванова'); // Привет!Аня Иванова
showMessage('Петя', secName); // Привет!Петя Петров
showMessage(name1, secName) // Привет!Вася Петров

/* -------------- №6 ---------------- */
/* ---- ПАРАМЕТРЫ ПО УМОЛЧАНИЮ ------ */
// Если при вызове функции мы передали не все необходимые аргументы, это вызовет ошибку
showMessage(name1) // Ошибка! не передано secondName
// Однако мы можем указать значение по умолчанию при объявлении функции – код будет работать корректно
// Укажем значения по умолчанию
function showMessage_(name = 'Аноним', secondName = 'Аноним') {
    // аргументы: name, secondName
    console.log('Привет!' + name + ' ' + secondName);
}
let name1_ = 'Вася'
let secName_ = "Петров"
showMessage_(name1_, secName_) // Привет!Вася Петров
// Попробуем вообще не передать значения
showMessage_() // Привет!Аноним Аноним

/* -------------- №7 ---------------- */
/* ----- ВОЗВРАЩАЕМОЕ ЗНАЧЕНИЕ ------ */
// простейший пример как вернуть
// посчитанное значение
// внутри функции
function sum(a, b) {
    return a + b;
}
let result = sum(1, 2);
console.log(result); // 3

// Результат функции зависит от age
function checkAge(age) {
    if (age >= 18) {
        return 'Совершеннолетний';
    } else {
        return 'Несовершеннолетний';
    }
}
// присваиваем res возвращаемое значение
let res = checkAge(18);
// выводим res
console.log(res) // Совершеннолетний

/* --------------- №8 --------------- */
/* ------- СТРЕЛОЧНАЯ ФУНКЦИЯ ------- */
// Как это выглядит:
/*
let func = (arg1, arg2, ...argN) => expression;
// на привычном синтаксисе это выглядит так
let func = function (arg1, arg2, ...argN) {
    return expression;
};
*/
/* Более короткая форма для:
let sum = function(a, b) {
 return a + b;
};
*/
let sum = (a, b) => a + b;
console.log(sum(1, 2)); // 3
// Чтобы записать многострочную стрелочную функцию - используются фигурные скобки
let sum = (a, b) => {
    // фигурная скобка, открывающая тело многострочной функции
    let result = a + b;
    // при фигурных скобках для возврата значения нужно явно вызвать return
    return result;
};
console.log(sum(1, 2)); // 3